package LATMOS::Accounts::Web::Controller::Json::AccAge;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Json::Expire - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    my $base = $c->model('Accounts')->db;

    my $graph = {
        data => [],
        series => [],
    };

    my $sortattr = $c->req->param('sort') || 'active';;
    my $inactive = $c->req->param('inactive');

    my %exists = map { $_ => 1 } $base->search_objects('user', 'active=1');
    my %create = $base->attributes_summary_by_object('user', 'create');
    my %sort = $base->attributes_summary_by_object('user', $sortattr);

    my %sortl;

    foreach (keys %sort) {
        if (!$c->req->param('inactive')) {
            $exists{$_} or next;
        }
        my $s = $sortattr eq 'active'
            ? ($exists{$_} ? 'active' : 'inactive')
            : $sort{$_}[0];
        $sortl{$s} = 1;
    }
    $sort{'(none)'} = 1;
    
    my %dates;
    foreach my $user (keys %create) {
        if (!$c->req->param('inactive')) {
            $exists{$user} or next;
        }
        foreach my $date (@{ $create{$user} }) {
            $date or next;
            $date =~ s/-.*//;
            my $status = $sortattr eq 'active'
                ? ($exists{$user} ? 'active' : 'inactive')
                : $sort{$user}[0];

            $status ||= '(none)';

            $dates{$_}{$date} ||= 0 foreach(keys %sortl);
            $dates{$status}{$date} ++;

            $sortl{$status} = 1;
        }
    }

    foreach my $status (sort keys %sortl) {
        push(@{ $graph->{data} }, [ map { [ $_, $dates{$status}{$_} +0 ] } sort { $a cmp $b } keys %{ $dates{$status} } ]);
        push(@{ $graph->{series} }, { label => $status });
    } 
    
    $c->stash->{data} = $graph;
}



=encoding utf8

=head1 AUTHOR

Olivier Thauvin,Guyancourt - B1428,+33 1 80285052,

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
